/****************************************************************************
 * tx.feature.read_foreach
 *   A mixin "Read_Foreach" that suplies the foreach/opApply constructs
 *   of TextReaders.
 ****************************************************************************/

module tx.feature.read_foreach;



template Read_Foreach(alias base)
{
public:
	int opApply( int delegate(ref string) dg )
	{
		return opApply( (ref uint _, ref string s){return dg(s);} );
	}

	int opApply( int delegate(ref uint, ref string) dg )
	{
		uint lineNo = 1;
		while( hasNextLine() )
		{
			string line = nextLine();
			if( int r = dg(lineNo, line) )
				return r;
			++lineNo;
		}
		return 0;
	}
}
